Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.media.opengl.awt
Class GLCanvas

    java.lang.Object
      java.awt.Component
          java.awt.Canvas
              javax.media.opengl.awt.GLCanvas

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable, Accessible, AWTGLAutoDrawable, ComponentEvents, GLAutoDrawable, GLDrawable

    public class GLCanvas

extends Canvas
implements AWTGLAutoDrawable

A heavyweight AWT component which provides OpenGL rendering support. This is the primary implementation of `GLDrawable`; `GLJPanel` is provided for compatibility with Swing user interfaces when adding a heavyweight doesn't work either because of Z-ordering or LayoutManager problems.

See Also:
  Serialized Form

Nested Class Summary
`protected static interface` | `GLCanvas.DestroyMethod`

Nested classes/interfaces inherited from class java.awt.Canvas
`Canvas.AccessibleAWTCanvas`

Nested classes/interfaces inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface javax.media.opengl.GLAutoDrawable
`SCREEN_CHANGE_ACTION_ENABLED`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`GLCanvas()` Creates a new GLCanvas component with a default set of OpenGL capabilities, using the default OpenGL capabilities selection mechanism, on the default screen device.
`GLCanvas(GLCapabilities capabilities)` Creates a new GLCanvas component with the requested set of OpenGL capabilities, using the default OpenGL capabilities selection mechanism, on the default screen device.
`GLCanvas(GLCapabilities capabilities, GLCapabilitiesChooser chooser, GLContext shareWith, GraphicsDevice device)` Creates a new GLCanvas component.

Method Summary
`protected static Object` | `addClosingListener(Component c, GLCanvas.DestroyMethod d)`
`void` | `addGLEventListener(GLEventListener listener)` Adds a `GLEventListener` to this drawable.
`void` | `addNotify()` Overridden to track when this component is added to a container.
`GLContext` | `createContext(GLContext shareWith)` Creates a new context for drawing to this drawable that will optionally share display lists and other server-side OpenGL objects with the specified GLContext.
`void` | `destroy()` Just an alias for removeNotify
`void` | `display()` Causes OpenGL rendering to be performed for this GLAutoDrawable by calling `display(..)` for all registered `GLEventListener`s.
`protected void` | `dispose(boolean regenerate)`
`boolean` | `getAutoSwapBufferMode()` Indicates whether automatic buffer swapping is enabled for this drawable.
`GLCapabilities` | `getChosenGLCapabilities()` Fetches the `GLCapabilities` corresponding to the chosen OpenGL capabilities (pixel format / visual / GLProfile) for this drawable. On some platforms, the pixel format is not directly associated with the drawable; a best attempt is made to return a reasonable value in this case.
`GLContext` | `getContext()` Returns the context associated with this drawable.
`GLDrawableFactory` | `getFactory()`
`GL` | `getGL()` Returns the `GL` pipeline object this GLAutoDrawable uses.
`GLProfile` | `getGLProfile()` Fetches the `GLProfile` for this drawable.
`GraphicsConfiguration` | `getGraphicsConfiguration()` Overridden to choose a GraphicsConfiguration on a parent container's GraphicsDevice because both devices
`NativeWindow` | `getNativeWindow()`
`GLCapabilities` | `getRequestedGLCapabilities()`
`protected static Window` | `getWindow(Component c)`
`void` | `paint(Graphics g)` Overridden to cause OpenGL rendering to be performed during repaint cycles.
`void` | `removeGLEventListener(GLEventListener listener)` Removes a `GLEventListener` from this drawable.
`void` | `removeNotify()` Overridden to track when this component is removed from a container.
`void` | `reshape(int x, int y, int width, int height)` Overridden to cause `GLDrawableHelper.reshape(javax.media.opengl.GLAutoDrawable, int, int, int, int)` to be called on all registered `GLEventListener`s.
`void` | `setAutoSwapBufferMode(boolean onOrOff)` Enables or disables automatic buffer swapping for this drawable.
`void` | `setContext(GLContext ctx)` Associate a new context to this drawable.
`GL` | `setGL(GL gl)` Sets the `GL` pipeline object this GLAutoDrawable uses.
`void` | `setRealized(boolean realized)` Indicates to on-screen GLDrawable implementations whether the underlying window has been created and can be drawn into.
`void` | `swapBuffers()` Swaps the front and back buffers of this drawable.
`String` | `toString()`
`void` | `update(Graphics g)` Overrides: `update` in class `java.awt.Component`

Methods inherited from class java.awt.Canvas
`createBufferStrategy, createBufferStrategy, getAccessibleContext, getBufferStrategy`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAlignmentX, getAlignmentY, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeys, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMinimumSize, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusCycleRoot, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, minimumSize, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, paramString, postEvent, preferredSize, prepareImage, prepareImage, print, printAll, processComponentEvent, processEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeys, setFocusTraversalKeysEnabled, setFont, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle, validate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.media.opengl.awt.AWTGLAutoDrawable
`repaint, setSize`

Methods inherited from interface javax.media.opengl.GLDrawable
`getHeight, getWidth`

Methods inherited from interface javax.media.opengl.awt.ComponentEvents
`addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener`

Constructor Detail

### GLCanvas

    public GLCanvas()

  Creates a new GLCanvas component with a default set of OpenGL capabilities, using the default OpenGL capabilities selection mechanism, on the default screen device.

### GLCanvas

    public GLCanvas(GLCapabilities capabilities)

  Creates a new GLCanvas component with the requested set of OpenGL capabilities, using the default OpenGL capabilities selection mechanism, on the default screen device.

### GLCanvas

    public GLCanvas(GLCapabilities capabilities,
                    GLCapabilitiesChooser chooser,
                    GLContext shareWith,
                    GraphicsDevice device)

  Creates a new GLCanvas component. The passed GLCapabilities specifies the OpenGL capabilities for the component; if null, a default set of capabilities is used. The GLCapabilitiesChooser specifies the algorithm for selecting one of the available GLCapabilities for the component; a DefaultGLCapabilitesChooser is used if null is passed for this argument. The passed GLContext specifies an OpenGL context with which to share textures, display lists and other OpenGL state, and may be null if sharing is not desired. See the note in the overview documentation on context sharing. The passed GraphicsDevice indicates the screen on which to create the GLCanvas; the GLDrawableFactory uses the default screen device of the local GraphicsEnvironment if null is passed for this argument.

Method Detail

### addClosingListener

    protected static final Object addClosingListener(Component c,
                                                     GLCanvas.DestroyMethod d)

### getWindow

    protected static final Window getWindow(Component c)

### getGraphicsConfiguration

    public GraphicsConfiguration getGraphicsConfiguration()

  Overridden to choose a GraphicsConfiguration on a parent container's GraphicsDevice because both devices

  Overrides:
    `getGraphicsConfiguration` in class `Component`

### createContext

    public GLContext createContext(GLContext shareWith)

  Description copied from interface: `GLDrawable`
  Creates a new context for drawing to this drawable that will optionally share display lists and other server-side OpenGL objects with the specified GLContext.

  The GLContext `share` need not be associated with this GLDrawable and may be null if sharing of display lists and other objects is not desired. See the note in the overview documentation on context sharing.

  Specified by:
    `createContext` in interface `GLDrawable`

### setRealized

    public void setRealized(boolean realized)

  Description copied from interface: `GLDrawable`
  Indicates to on-screen GLDrawable implementations whether the underlying window has been created and can be drawn into. End users do not need to call this method; it is not necessary to call `setRealized` on a GLCanvas, a GLJPanel, or a GLPbuffer, as these perform the appropriate calls on their underlying GLDrawables internally.

  Developers implementing new OpenGL components for various window toolkits need to call this method against GLDrawables obtained from the GLDrawableFactory via the `GLDrawableFactory.getGLDrawable()` method. It must typically be called with an argument of `true` when the component associated with the GLDrawable is realized and with an argument of `false` just before the component is unrealized. For the AWT, this means calling `setRealized(true)` in the `addNotify` method and with an argument of `false` in the `removeNotify` method.

  `GLDrawable` implementations should handle multiple cycles of `setRealized(true)` / `setRealized(false)` calls. Most, if not all, Java window toolkits have a persistent object associated with a given component, regardless of whether that component is currently realized. The `GLDrawable` object associated with a particular component is intended to be similarly persistent. A `GLDrawable` is intended to be created for a given component when it is constructed and live as long as that component. `setRealized` allows the `GLDrawable` to re-initialize and destroy any associated resources as the component becomes realized and unrealized, respectively.

  With an argument of `true`, the minimum implementation shall call `NativeWindow's lockSurface()` and if successfull:

  - Update the `GLCapabilities`, which are associated with the attached `NativeWindow`'s `AbstractGraphicsConfiguration`.
  - Release the lock with `NativeWindow's unlockSurface()`.
  This is important since `NativeWindow's lockSurface()` ensures resolving the window/surface handles, and the drawable's `GLCapabilities` might have changed.

  Calling this method has no other effects. For example, if `removeNotify` is called on a Canvas implementation for which a GLDrawable has been created, it is also necessary to destroy all OpenGL contexts associated with that GLDrawable. This is not done automatically by the implementation.

  Specified by:
    `setRealized` in interface `GLDrawable`

### display

    public void display()

  Description copied from interface: `GLAutoDrawable`
  Causes OpenGL rendering to be performed for this GLAutoDrawable by calling `display(..)` for all registered `GLEventListener`s. Called automatically by the window system toolkit upon receiving a repaint() request. this routine may be called manually for better control over the rendering process. It is legal to call another GLAutoDrawable's display method from within the `display(..)` callback.

  In case of a new generated OpenGL context, the implementation shall call `init(..)` for all registered `GLEventListener`s before making the actual `display(..)` calls, in case this has not been done yet.

  Specified by:
    `display` in interface `GLAutoDrawable`

### dispose

    protected void dispose(boolean regenerate)

### destroy

    public void destroy()

  Just an alias for removeNotify

  Specified by:
    `destroy` in interface `GLAutoDrawable`

### paint

    public void paint(Graphics g)

  Overridden to cause OpenGL rendering to be performed during repaint cycles. Subclasses which override this method must call super.paint() in their paint() method in order to function properly.

  Overrides:

    `paint` in class `java.awt.Component`

  Overrides:
    `paint` in class `Canvas`

### addNotify

    public void addNotify()

  Overridden to track when this component is added to a container. Subclasses which override this method must call super.addNotify() in their addNotify() method in order to function properly.

  Overrides:

    `addNotify` in class `java.awt.Component`

  Overrides:
    `addNotify` in class `Canvas`

### removeNotify

    public void removeNotify()

  Overridden to track when this component is removed from a container. Subclasses which override this method must call super.removeNotify() in their removeNotify() method in order to function properly.

  Overrides:

    `removeNotify` in class `java.awt.Component`

  Overrides:
    `removeNotify` in class `Component`

### reshape

    public void reshape(int x,
                        int y,
                        int width,
                        int height)

  Overridden to cause `GLDrawableHelper.reshape(javax.media.opengl.GLAutoDrawable, int, int, int, int)` to be called on all registered `GLEventListener`s. Subclasses which override this method must call super.reshape() in their reshape() method in order to function properly.

  Overrides:

    `reshape` in class `java.awt.Component`

  Overrides:
    `reshape` in class `Component`

### update

    public void update(Graphics g)

  Overrides:
    `update` in class `java.awt.Component`

  Overrides:
    `update` in class `Canvas`

### addGLEventListener

    public void addGLEventListener(GLEventListener listener)

  Description copied from interface: `GLAutoDrawable`
  Adds a `GLEventListener` to this drawable. If multiple listeners are added to a given drawable, they are notified of events in an arbitrary order.

  Specified by:
    `addGLEventListener` in interface `GLAutoDrawable`

### removeGLEventListener

    public void removeGLEventListener(GLEventListener listener)

  Description copied from interface: `GLAutoDrawable`
  Removes a `GLEventListener` from this drawable. Note that if this is done from within a particular drawable's `GLEventListener` handler (reshape, display, etc.) that it is not guaranteed that all other listeners will be evaluated properly during this update cycle.

  Specified by:
    `removeGLEventListener` in interface `GLAutoDrawable`

### setContext

    public void setContext(GLContext ctx)

  Description copied from interface: `GLAutoDrawable`
  Associate a new context to this drawable.

  Specified by:
    `setContext` in interface `GLAutoDrawable`

### getContext

    public GLContext getContext()

  Description copied from interface: `GLAutoDrawable`
  Returns the context associated with this drawable. The returned context will be synchronized. Don't rely on it's identity, the context may change.

  Specified by:
    `getContext` in interface `GLAutoDrawable`

### getGL

    public GL getGL()

  Description copied from interface: `GLAutoDrawable`
  Returns the `GL` pipeline object this GLAutoDrawable uses. If this method is called outside of the `GLEventListener`'s callback methods (init, display, etc.) it may return null. Users should not rely on the identity of the returned GL object; for example, users should not maintain a hash table with the GL object as the key. Additionally, the GL object should not be cached in client code, but should be re-fetched from the GLAutoDrawable at the beginning of each call to init, display, etc.

  Specified by:
    `getGL` in interface `GLAutoDrawable`

### setGL

    public GL setGL(GL gl)

  Description copied from interface: `GLAutoDrawable`
  Sets the `GL` pipeline object this GLAutoDrawable uses. This should only be called from within the GLEventListener's callback methods, and usually only from within the init() method, in order to install a composable pipeline. See the JOGL demos for examples.

  Specified by:
    `setGL` in interface `GLAutoDrawable`
  Returns:
    the set GL pipeline or null if not successful

### setAutoSwapBufferMode

    public void setAutoSwapBufferMode(boolean onOrOff)

  Description copied from interface: `GLAutoDrawable`
  Enables or disables automatic buffer swapping for this drawable. By default this property is set to true; when true, after all GLEventListeners have been called for a display() event, the front and back buffers are swapped, displaying the results of the render. When disabled, the user is responsible for calling `GLDrawable.swapBuffers(..)` manually.

  Specified by:
    `setAutoSwapBufferMode` in interface `GLAutoDrawable`

### getAutoSwapBufferMode

    public boolean getAutoSwapBufferMode()

  Description copied from interface: `GLAutoDrawable`
  Indicates whether automatic buffer swapping is enabled for this drawable. See `GLAutoDrawable.setAutoSwapBufferMode(boolean)`.

  Specified by:
    `getAutoSwapBufferMode` in interface `GLAutoDrawable`

### swapBuffers

    public void swapBuffers()

  Description copied from interface: `GLDrawable`
  Swaps the front and back buffers of this drawable. For `GLAutoDrawable` implementations, when automatic buffer swapping is enabled (as is the default), this method is called automatically and should not be called by the end user.

  Specified by:
    `swapBuffers` in interface `GLDrawable`

### getGLProfile

    public GLProfile getGLProfile()

  Description copied from interface: `GLDrawable`
  Fetches the `GLProfile` for this drawable. Returns the GLProfile object, no copy.

  Specified by:
    `getGLProfile` in interface `GLDrawable`

### getChosenGLCapabilities

    public GLCapabilities getChosenGLCapabilities()

  Description copied from interface: `GLDrawable`
  Fetches the `GLCapabilities` corresponding to the chosen OpenGL capabilities (pixel format / visual / GLProfile) for this drawable.
  On some platforms, the pixel format is not directly associated with the drawable; a best attempt is made to return a reasonable value in this case.
  This object shall be directly associated to the attached `NativeWindow`'s `AbstractGraphicsConfiguration`, and if changes are necessary, they should reflect those as well.

  Specified by:
    `getChosenGLCapabilities` in interface `GLDrawable`
  Returns:
    A copy of the queried object.

### getRequestedGLCapabilities

    public GLCapabilities getRequestedGLCapabilities()

### getNativeWindow

    public NativeWindow getNativeWindow()

  Specified by:
    `getNativeWindow` in interface `GLDrawable`

### getFactory

    public GLDrawableFactory getFactory()

  Specified by:
    `getFactory` in interface `GLDrawable`

### toString

    public String toString()

  Specified by:
    `toString` in interface `GLDrawable`
  Overrides:
    `toString` in class `Component`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2005 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms.